#pragma message ( "including pmwritea.cc (pixel to screen aa (masked))" );
//#define TRICKY

#ifndef DEBUG_MSG
 #ifndef BANKED
// enable the outcommented stuff to get rid of the twinkling of
// anti aliased lines, but games like spike's hopping depend
// on overwriting bright pixels with less bright pixel...
  #ifdef TRICKY
     if ((*(dest+offset)&15)<T_COLOR)
  #endif
     *(dest+offset)=(T_UCHAR)T_COLOR COLOR_MODIFIER;
 #else // #ifndef BANKED
     offset_x=(T_UWORD)(offset&vesa_and_x);
  #ifdef TRICKY
     if (vesa_address_of_window[vesa_read_window]!=(new_win_address=(T_UWORD)(offset>>vesa_granularity_potenz)))
     {
      vesa_address_of_window[vesa_read_window]=new_win_address;
      vesa_set_read_window();
     }
     if (((*((T_PUCHAR )(vesa_read_seg+offset_x))) &15)<T_COLOR)
  #endif
     {
      if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(T_UWORD)(offset>>vesa_granularity_potenz)))
      {
       vesa_address_of_window[vesa_write_window]=new_win_address;
       vesa_set_write_window();
      }
      *((T_PUCHAR )(vesa_write_seg+offset_x))=(T_UCHAR)T_COLOR COLOR_MODIFIER;
     }
 #endif // else #ifndef BANKED
#else // #ifndef DEBUG_MSG
     pixel=(T_UCHAR)T_COLOR COLOR_MODIFIER;
 #ifndef BANKED
  #ifdef TRICKY
     if ((*(dest+offset)&15)<T_COLOR)
  #endif
     {
      *(dest+offset)=pixel;
     }
     *(back+offset)=pixel;
 #else // #ifndef BANKED
     offset_x=(T_UWORD)(offset&vesa_and_x);
  #ifdef TRICKY
     if (vesa_address_of_window[vesa_read_window]!=(new_win_address=(T_UWORD)(offset>>vesa_granularity_potenz)))
     {
      vesa_address_of_window[vesa_read_window]=new_win_address;
      vesa_set_read_window();
     }
     if (((*((T_PUCHAR )(vesa_read_seg+offset_x)))&15)<T_COLOR)
  #endif
     {
      if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(T_UWORD)(offset>>vesa_granularity_potenz)))
      {
       vesa_address_of_window[vesa_write_window]=new_win_address;
       vesa_set_write_window();
      }
      *((T_PUCHAR )(vesa_write_seg+offset_x))=pixel;
     }
     *(back+offset)=pixel;
 #endif // #else // #ifndef BANKED
   }
   else
   {
    if (!((*(clip_memory+offset))&1))
    {
     *(back+offset)=(T_UCHAR)T_COLOR COLOR_MODIFIER;
    }
#endif // #else // #ifndef DEBUG_MSG
//#undef TRICKY
